<?php

 /* script parses icecast v2.3.1 statistical xml page
    script requires access to stats.xml file (basicaly http://icecastAdminName:icecastAdminPassword@yourserver.com:8000/admin/stats.xml)
    see commented sections at the end of this file for example usages
    author: amnesiac@netzond.com
 */

DEFINE('IP_ADDRESS',	'127.0.0.1:8000');
DEFINE('USERNAME',	'admin');
DEFINE('PASSWORD',	'hackme');

/*
 *by default icecast server assumes <clients>=listeners count per each mount + sources count
 *to fix this value (so that <clients>=listeners count per each mount) set correct_clients constant to TRUE
 */
DEFINE('correct_clients',true);
DEFINE('bytes_to_bits',true);

function get_http_data() {
    if (strlen(PASSWORD)+strlen(USERNAME)>0) $link = USERNAME.":".PASSWORD."@".IP_ADDRESS;
    else $link=IP_ADDRESS;
    
    $link="http://$link/admin/stats.xml";
    
    $skip=strlen('<?xml version="1.0" ?> ')-1;
    
    $web=fopen($link,r); if (!$web) return false;
    $content=stream_get_contents($web,'-1',$skip);
    fclose($web);
    
    return trim($content);
}

function parse_xml($xml) {
    $p = xml_parser_create();
    xml_parse_into_struct($p, $xml, $values, $indexes);
    xml_parser_free($p);

    foreach ($indexes as $index => $sub_values) if (count($indexes[$index])==1) $global[$index]=$values[$sub_values[0]]['value'];
    
    for ($i=0; $i<count($indexes['SOURCE']);$i++) {
	$mount = substr($values[$indexes['SOURCE'][$i]]['attributes']['MOUNT'],1);
	
	for ($j=$indexes['SOURCE'][$i]+1; $j<$indexes['SOURCE'][$i+1]; $j++) 
	    if (bytes_to_bits && ($values[$j]['tag']=='TOTAL_BYTES_READ' || $values[$j]['tag']=='TOTAL_BYTES_SENT')) {
		$global[$mount][str_replace('BYTE','BIT',$values[$j]['tag'])] = $values[$j]['value']*8;
	    } else {
		$global[$mount][$values[$j]['tag']] = $values[$j]['value'];
	    }
	$i++;
    }
    if (correct_clients) $global['CLIENTS']=($global['CLIENTS']-$global['SOURCES']);
    return($global);    
}

/*
 *$silent=true - returns php array
 *$silent=false - prints data present in array
 */
function retrieve($tags,$silent) {

    $data = parse_xml(get_http_data());

    if ((!is_array($tags)) && $tags=='list_tags') return ($data);

    foreach ($tags as $tag) {
	if (is_array($tag)) $output[]=$data[$tag[0]][strtoupper($tag[1])];
	else $output[]=$data[strtoupper($tag)];
    }

    if (isset($output) && count($output)>0) 
	if ($silent) return $output;
	else echo implode("\n",$output)."\n";
}

/*
 if (count($_SERVER['argv'])==1 && empty($_REQUEST)) die("usage: ".$_SERVER['PHP_SELF']." list_tags| tag1 mount1:tag7 mount2:tag3 \n");
 if ($_SERVER['argv'][1]=='list_tags') {
    print_r(retrieve('list_tags',false));die;
 } elseif (count($_SERVER['argv'])>=2) {
    for ($i=1; $i<count($_SERVER['argv']); $i++) {
	if (stristr($_SERVER['argv'][$i],':') == false) $tags[]=$_SERVER['argv'][$i];
	else $tags[]=explode(":",$_SERVER['argv'][$i]);
    }
 } elseif (count($_REQUEST)>0) {
    foreach ($_REQUEST as $tag => $value) 
	if (stristr($tag,':') == false) $tags[]=$tag;
	else $tags[]=explode(":",$tag);
 }

 retrieve($tags,false);
 */

?>
